diff --git a/src/main/java/net/minecraft/core/util/helper/LoggedPrintStream.java b/src/main/java/net/minecraft/core/util/helper/LoggedPrintStream.java
new file mode 100644
index 000000000..5d3d8efe9
--- /dev/null
+++ b/src/main/java/net/minecraft/core/util/helper/LoggedPrintStream.java
@@ -0,0 +1,55 @@
+package net.minecraft.core.util.helper;
+
+import com.mojang.logging.LogUtils;
+import org.jetbrains.annotations.Nullable;
+import org.slf4j.Logger;
+
+import java.io.OutputStream;
+import java.io.PrintStream;
+
+public class LoggedPrintStream extends PrintStream
+{
+	private static final Logger LOGGER = LogUtils.getLogger();
+	protected final String name;
+
+	public LoggedPrintStream(final String name, final OutputStream sourceStream) {
+		super(sourceStream);
+		this.name = name;
+	}
+	public static void wrapStreams() {
+		System.setErr(new LoggedPrintStream("STDERR", System.err));
+		System.setOut(new LoggedPrintStream("STDOUT", System.out));
+	}
+
+	@Override
+	public void println(@Nullable final String message) {
+		this.logLine(message);
+	}
+
+	@Override
+	public void println(final Object object) {
+		this.logLine(String.valueOf(object));
+	}
+
+	protected void logLine(@Nullable final String $$0) {
+		LoggedPrintStream.LOGGER.info("[{}]: {}", this.name, $$0);
+	}
+
+    public static String removeColorCodes(String string) {
+		StringBuilder builder = new StringBuilder();
+		
+		boolean a = false;
+		for(int i=0; i < string.length(); i++) {
+			char c = string.charAt(i);
+			if(c == '§') {
+				a = true;
+			}else if(a) {
+				a = false;
+			}else {
+				builder.append(c);
+			}
+		}
+		return builder.toString();
+	}
+	
+}
diff --git a/src/main/java/net/minecraft/core/util/helper/ReflectionHelper.java b/src/main/java/net/minecraft/core/util/helper/ReflectionHelper.java
index 758210d56..48468b9a0 100644
--- a/src/main/java/net/minecraft/core/util/helper/ReflectionHelper.java
+++ b/src/main/java/net/minecraft/core/util/helper/ReflectionHelper.java
@@ -9,9 +9,11 @@ import java.util.zip.ZipFile;
 
 import com.b100.utils.FileUtils;
 import com.b100.utils.interfaces.Condition;
+import com.mojang.logging.LogUtils;
+import org.slf4j.Logger;
 
 public abstract class ReflectionHelper {
-	
+	private static final Logger LOGGER = LogUtils.getLogger();
 	public static List<Class<?>> getAllClasses(Condition<String> classNameCondition) {
 		ClassLoader classLoader = ClassLoader.getSystemClassLoader();
 		List<Class<?>> classes = new ArrayList<Class<?>>();
@@ -43,7 +45,7 @@ public abstract class ReflectionHelper {
 					}
 					zip.close();
 				} catch (IOException e) {
-					e.printStackTrace();
+                    LOGGER.error("Exception loading class entries from file '{}'!", file.getPath(), e);
 				}
 				
 			}
diff --git a/src/main/java/net/minecraft/core/util/helper/ScreenShot.java b/src/main/java/net/minecraft/core/util/helper/ScreenShot.java
index 843f079b3..0227155db 100644
--- a/src/main/java/net/minecraft/core/util/helper/ScreenShot.java
+++ b/src/main/java/net/minecraft/core/util/helper/ScreenShot.java
@@ -9,14 +9,16 @@ import java.util.Date;
 
 import javax.imageio.ImageIO;
 
+import com.mojang.logging.LogUtils;
 import org.lwjgl.BufferUtils;
 import org.lwjgl.opengl.GL11;
 
 import com.b100.utils.ImageUtils;
+import org.slf4j.Logger;
 
 public class ScreenShot
 {
-
+    private static final Logger LOGGER = LogUtils.getLogger();
     public static String saveScreenshot(File mcDir, int width, int height)
     {
         try
@@ -37,9 +39,9 @@ public class ScreenShot
             buffer.clear();
             GL11.glReadPixels(0, 0, width, height, 6407 /*GL_RGB*/, 5121 /*GL_UNSIGNED_BYTE*/, buffer);
             buffer.clear();
-            String s = "" + dateFormat.format(new Date());
-            File file2;
-            for(int k = 1; (file2 = new File(screenshotsDir, s + (k != 1 ? "_" + k : "") + ".png")).exists(); k++) { }
+            String dateString = dateFormat.format(new Date());
+            File destFile;
+            for(int k = 1; (destFile = new File(screenshotsDir, dateString + (k != 1 ? "_" + k : "") + ".png")).exists(); k++) { }
             buffer.get(pixelData);
             for(int l = 0; l < width; l++)
             {
@@ -57,24 +59,24 @@ public class ScreenShot
 
             BufferedImage bufferedimage = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
             bufferedimage.setRGB(0, 0, width, height, imageData, 0, width);
-            ImageIO.write(bufferedimage, "png", file2);
+            ImageIO.write(bufferedimage, "png", destFile);
             try {
             	ImageUtils.copyImageToClipboard(bufferedimage);
             }catch (Exception e) {
-            	e.printStackTrace();
+                LOGGER.error("Exception copying image to clipboard!", e);
 			}
-            return "Saved screenshot as " + file2.getName();
+            return "Saved screenshot as " + destFile.getName();
         }
         catch(Exception exception)
         {
-            exception.printStackTrace();
+            LOGGER.error("Failed to save screenshot!", exception);
             return "Failed to save: " + exception;
         }
     }
 
     private static DateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd_HH.mm.ss");
     private static ByteBuffer buffer;
-    private static byte pixelData[];
-    private static int imageData[];
+    private static byte[] pixelData;
+    private static int[] imageData;
 
 }
diff --git a/src/main/java/net/minecraft/core/util/helper/UUIDHelper.java b/src/main/java/net/minecraft/core/util/helper/UUIDHelper.java
new file mode 100644
index 000000000..9c763bb47
--- /dev/null
+++ b/src/main/java/net/minecraft/core/util/helper/UUIDHelper.java
@@ -0,0 +1,118 @@
+package net.minecraft.core.util.helper;
+
+import com.b100.json.JsonParser;
+import com.b100.json.element.JsonObject;
+import com.b100.utils.StringUtils;
+import com.mojang.nbt.CompoundTag;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.HashMap;
+import java.util.Map;
+import java.util.UUID;
+
+public class UUIDHelper {
+    private static final String urlUUID = "https://api.mojang.com/users/profiles/minecraft/";
+
+    private static final JsonParser jsonParser = new JsonParser();
+    private static final Map<String, UUID> nameToUUIDMap = new HashMap<>();
+
+    public static boolean isUUID(String usernameOrUUID) {
+        return usernameOrUUID.length() == 36 || usernameOrUUID.length() == 32;
+    }
+
+    public static void runConversionAction(String username, @Nullable UUIDFunction successAction, @Nullable StringFunction failAction) {
+        if (nameToUUIDMap.containsKey(username)) {
+            UUID uuid = nameToUUIDMap.get(username);
+            if (uuid != null) {
+                if (successAction != null) {
+                    successAction.run(uuid);
+                }
+            } else {
+                if (failAction != null) {
+                    failAction.run(username);
+                }
+            }
+            return;
+        }
+        new Thread(() -> {
+            try {
+                UUID uuid = getUUIDFromName(username);
+                if (uuid != null) {
+                    if (successAction != null) {
+                        successAction.run(uuid);
+                    }
+                    nameToUUIDMap.put(username, uuid);
+                } else {
+                    if (failAction != null) {
+                        failAction.run(username);
+                    }
+                    nameToUUIDMap.put(username, null);
+                }
+            } catch (Exception e) {
+                e.printStackTrace();
+                if (failAction != null) {
+                    failAction.run(username);
+                }
+            }
+        }).start();
+    }
+    public static @Nullable UUID getUUIDFromName(String username){
+        String string;
+        try{
+            string = StringUtils.getWebsiteContentAsString(urlUUID + username);
+        }catch (Exception e) {
+            System.err.println("Can't connect to Mojang API.");
+            e.printStackTrace();
+            return null;
+        }
+        if(string.isEmpty()) {
+            System.err.println("Player "+username+" doesn't exist!");
+            return null;
+        }
+        String uuid;
+        try {
+            JsonObject contentParsed = jsonParser.parse(string);
+            uuid = contentParsed.getString("id");
+        }catch (Exception e) {
+            e.printStackTrace();
+            return null;
+        }
+        if (uuid == null) return null;
+        uuid = untrimUUID(uuid);
+        return UUID.fromString(uuid);
+    }
+
+    public static String untrimUUID(String uuid) {
+        if (uuid.length() == 32) { // Untrim trimmed UUID
+            String s1 = uuid.substring(0, 8);
+            String s2 = uuid.substring(8, 12);
+            String s3 = uuid.substring(12, 16);
+            String s4 = uuid.substring(16, 20);
+            String s5 = uuid.substring(20, 32);
+            return s1 + "-" + s2 + "-" + s3 + "-" + s4 + "-" + s5;
+        }
+        return uuid;
+    }
+
+    public static @Nullable UUID readFromTag(@NotNull CompoundTag tag, @NotNull String keyBase) {
+        if (!tag.containsKey(keyBase + "_msb") || !tag.containsKey(keyBase + "_lsb")) return null;
+        long msb = tag.getLong(keyBase + "_msb");
+        long lsb = tag.getLong(keyBase + "_lsb");
+        return new UUID(msb, lsb);
+    }
+
+    public static void writeToTag(@NotNull CompoundTag tag, @Nullable UUID uuid, @NotNull String keyBase) {
+        if (uuid != null) {
+            tag.putLong(keyBase + "_msb", uuid.getMostSignificantBits());
+            tag.putLong(keyBase + "_lsb", uuid.getLeastSignificantBits());
+        }
+    }
+
+    public interface StringFunction {
+        void run(String s);
+    }
+    public interface UUIDFunction {
+        void run(UUID s);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/util/helper/Utils.java b/src/main/java/net/minecraft/core/util/helper/Utils.java
index ff0163137..5a3df5ad6 100644
--- a/src/main/java/net/minecraft/core/util/helper/Utils.java
+++ b/src/main/java/net/minecraft/core/util/helper/Utils.java
@@ -1,9 +1,13 @@
 package net.minecraft.core.util.helper;
 
+import com.mojang.logging.LogUtils;
+import org.slf4j.Logger;
+
 import java.awt.Desktop;
 import java.io.File;
 
 public abstract class Utils {
+	private static final Logger LOGGER = LogUtils.getLogger();
 	
 	public static final String hexString = "0123456789ABCDEF";
 	
@@ -39,18 +43,17 @@ public abstract class Utils {
 	
 	public static void openDirectory(File file) {
 		if(!file.exists()) {
-			System.out.println("Can't open directory '"+file.getAbsolutePath()+"' because it doesnt exist!");
+            LOGGER.warn("Can't open directory '{}' because it doesnt exist!", file.getAbsolutePath());
 			return;
 		}
 		if(!file.isDirectory()) {
-			System.out.println("Not a directory: '"+file.getAbsolutePath()+"'!");
+            LOGGER.warn("Not a directory: '{}'!", file.getAbsolutePath());
 			return;
 		}
 		try {
 			Desktop.getDesktop().open(file);
 		}catch (Exception e) {
-			System.err.println("Error opening directory '"+file.getAbsolutePath()+"'!");
-			e.printStackTrace();
+            LOGGER.error("Error opening directory '{}'!", file.getAbsolutePath(), e);
 		}
 	}
 	
diff --git a/src/main/java/net/minecraft/core/world/Explosion.java b/src/main/java/net/minecraft/core/world/Explosion.java
index af1baca0a..1e3435b56 100644
--- a/src/main/java/net/minecraft/core/world/Explosion.java
+++ b/src/main/java/net/minecraft/core/world/Explosion.java
@@ -88,7 +88,7 @@ public class Explosion {
             }
             if(id > 0)
             {
-                Block.blocksList[id].dropBlockWithCause(worldObj, EnumDropCause.EXPLOSION, x, y, z, worldObj.getBlockMetadata(x, y, z), blockEntity);
+                Block.blocksList[id].dropBlockWithCause(worldObj, EnumDropCause.EXPLOSION, x, y, z, worldObj.getBlockMetadata(x, y, z), blockEntity, null);
                 worldObj.setBlockWithNotify(x, y, z, 0);
                 Block.blocksList[id].onBlockDestroyedByExplosion(worldObj, x, y, z);
             }
diff --git a/src/main/java/net/minecraft/core/world/ExplosionCannonball.java b/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
index 3c4baa9fa..0ffb886b1 100644
--- a/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
+++ b/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
@@ -172,7 +172,7 @@ public class ExplosionCannonball extends Explosion{
                     ||  Block.blocksList[i1].blockMaterial == Material.decoration
                     ||  Block.blocksList[i1].blockMaterial == Material.ice))
             {
-                Block.blocksList[i1].dropBlockWithCause(worldObj, EnumDropCause.EXPLOSION, x, y, z, worldObj.getBlockMetadata(x, y, z), blockEntity);
+                Block.blocksList[i1].dropBlockWithCause(worldObj, EnumDropCause.EXPLOSION, x, y, z, worldObj.getBlockMetadata(x, y, z), blockEntity, null);
                 worldObj.setBlockWithNotify(x, y, z, 0);
                 Block.blocksList[i1].onBlockDestroyedByExplosion(worldObj, x, y, z);
             }
diff --git a/src/main/java/net/minecraft/core/world/SpawnerMobs.java b/src/main/java/net/minecraft/core/world/SpawnerMobs.java
index e76a443a7..8e2d7aa8a 100644
--- a/src/main/java/net/minecraft/core/world/SpawnerMobs.java
+++ b/src/main/java/net/minecraft/core/world/SpawnerMobs.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.world;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.block.BedBlock;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.data.gamerule.GameRules;
@@ -22,6 +23,7 @@ import net.minecraft.core.world.chunk.ChunkPosition;
 import net.minecraft.core.world.pathfinder.Node;
 import net.minecraft.core.world.pathfinder.Path;
 import net.minecraft.core.world.pathfinder.PathFinder;
+import org.slf4j.Logger;
 
 import java.util.Collection;
 import java.util.HashMap;
@@ -32,6 +34,7 @@ import java.util.Map;
 import java.util.Set;
 public final class SpawnerMobs
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
     private static final Set<ChunkCoordinate> eligibleChunksForSpawning = new HashSet<>();
     private static final Class<?>[] nightSpawnEntities;
 
@@ -166,7 +169,7 @@ public final class SpawnerMobs
                         try {
                             mobToSpawn = (Mob) spawnListEntry.entityClass.getConstructor(new Class[]{World.class}).newInstance(new Object[]{world});
                         } catch (Exception e) {
-                            new RuntimeException("Error spawning entity class '" + spawnListEntry.entityClass.getSimpleName() + "' class missing default constructor for World! Skipping spawn attempt!", e).printStackTrace();
+                            LOGGER.error("Error spawning entity class '{}' class missing default constructor for World! Skipping spawn attempt!", spawnListEntry.entityClass.getSimpleName(), e);
                             return totalSpawned;
                         }
 
@@ -189,9 +192,9 @@ public final class SpawnerMobs
         return totalSpawned;
     }
 
-    private static boolean canCreatureTypeSpawnAtLocation(MobCategory enumcreaturetype, World world, int x, int y, int z)
+    private static boolean canCreatureTypeSpawnAtLocation(MobCategory mobCategory, World world, int x, int y, int z)
     {
-        if(enumcreaturetype.getSpawnMaterial() == Material.water)
+        if(mobCategory.getSpawnMaterial() == Material.water)
         {
             return world.getBlockMaterial(x, y, z).isLiquid() && !world.isBlockNormalCube(x, y + 1, z);
         } else
@@ -266,13 +269,14 @@ public final class SpawnerMobs
 						float entityZ = z + 0.5f;
 						
 						Mob entity;
+                        Class<?> eClass= entityClasses[world.rand.nextInt(entityClasses.length)];
 						try
                         {
-							entity = (Mob) entityClasses[world.rand.nextInt(entityClasses.length)].getConstructor(World.class).newInstance(world);
+							entity = (Mob) eClass.getConstructor(World.class).newInstance(world);
 						}
                         catch (Exception e)
                         {
-							e.printStackTrace();
+                            LOGGER.error("Exception instancing class '{}'!", eClass.getSimpleName(), e);
 							return spawnedEntity;
 						}
 						
diff --git a/src/main/java/net/minecraft/core/world/World.java b/src/main/java/net/minecraft/core/world/World.java
index 5d9430b20..a0c38fa64 100644
--- a/src/main/java/net/minecraft/core/world/World.java
+++ b/src/main/java/net/minecraft/core/world/World.java
@@ -11,7 +11,9 @@ import java.util.List;
 import java.util.Random;
 import java.util.Set;
 import java.util.TreeSet;
+import java.util.UUID;
 
+import com.mojang.logging.LogUtils;
 import com.mojang.nbt.CompoundTag;
 
 import net.minecraft.client.option.enums.Difficulty;
@@ -70,9 +72,10 @@ import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.WeatherManager;
 import net.minecraft.core.world.weather.Weathers;
 import org.jetbrains.annotations.Nullable;
+import org.slf4j.Logger;
 
 public class World implements WorldSource {
-
+    private static final Logger LOGGER = LogUtils.getLogger();
     public static boolean AUTOSAVE = true;
 
     public static final int HEIGHT_BLOCKS = 256;
@@ -97,6 +100,9 @@ public class World implements WorldSource {
     public int skyDarken = 0;
     protected int updateLCG = new Random().nextInt();
     public int lightningFlicker = 0;
+    public int rainbowTicks = 0;
+    public int startingRainbowTicks = 0;
+    public boolean dayCanHaveRainbow = true;
     public boolean editingBlocks = false;
     private long lockTimestamp = System.currentTimeMillis();
     //protected int autosavePeriod = 40;
@@ -359,7 +365,7 @@ public class World implements WorldSource {
         }
         catch(Exception e)
         {
-            e.printStackTrace();
+            LOGGER.error("Failed to spawn player with loaded chunks!", e);
         }
     }
 
@@ -1389,6 +1395,10 @@ public class World implements WorldSource {
         return true;
     }
 
+    public void addRainbow(int rainbowTicks){
+        this.rainbowTicks = startingRainbowTicks = rainbowTicks;
+    }
+
     public boolean entityJoinedWorld(Entity entity)
     {
         int i = MathHelper.floor(entity.x / Chunk.CHUNK_SIZE_X);
@@ -2521,6 +2531,10 @@ public class World implements WorldSource {
 		updateBlocksAndPlayCaveSounds();
         Debug.change("season&light");
 		updateSeasonAndLight();
+        if(rainbowTicks > 0)
+        {
+            rainbowTicks--;
+        }
         Debug.pop();
 	}
 	
@@ -2531,6 +2545,11 @@ public class World implements WorldSource {
 		int currentDayCount = ((int) (levelData.getWorldTime() / Global.DAY_LENGTH_TICKS));
 		if(currentDayCount != dayCountLastTick) {
 			dayCountLastTick = currentDayCount;
+            if (!isClientSide){
+                dayCanHaveRainbow = rand.nextInt(3) == 0;
+            } else {
+                dayCanHaveRainbow = true;
+            }
 			seasonChanged = true;
 		}
 
@@ -2911,6 +2930,17 @@ public class World implements WorldSource {
         return null;
     }
 
+    public Player getPlayerEntityByUUID(UUID uuid)
+    {
+        for (Player player : players) {
+            if (uuid.equals(player.uuid)) {
+                return player;
+            }
+        }
+
+        return null;
+    }
+
     public void setChunkData(int x, int y, int z, int width, int height, int length, byte[] data)
     {
         int minChunkX = Math.floorDiv(x, Chunk.CHUNK_SIZE_X);
diff --git a/src/main/java/net/minecraft/core/world/biome/data/BiomeRangeMap.java b/src/main/java/net/minecraft/core/world/biome/data/BiomeRangeMap.java
index 3744485b5..2205a37e8 100644
--- a/src/main/java/net/minecraft/core/world/biome/data/BiomeRangeMap.java
+++ b/src/main/java/net/minecraft/core/world/biome/data/BiomeRangeMap.java
@@ -1,19 +1,19 @@
 package net.minecraft.core.world.biome.data;
 
 import com.b100.utils.ImageUtils;
-import net.minecraft.core.Global;
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.biome.Biome;
+import org.slf4j.Logger;
 
-import javax.imageio.ImageIO;
 import java.awt.*;
 import java.awt.image.BufferedImage;
-import java.io.File;
 import java.util.*;
 
 public final class BiomeRangeMap
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
     private final Map<Biome, Set<BiomeRange>> ranges = new LinkedHashMap<>();
     private BiomeRangeLookup lookup = null;
 
@@ -55,7 +55,7 @@ public final class BiomeRangeMap
                         Biome biome = lookupBiome(temperature, humidity, altitude, variety);
 
                         if (biome == null) {
-                            System.out.println("Gap found in biome map at:\nTemperature: " + temperature + "\nHumidity: " + humidity + "\nAltitude: " + altitude);
+                            LOGGER.warn("Gap found in biome map at:\nTemperature: {}\nHumidity: {}\nAltitude: {}", temperature, humidity, altitude);
                             return true;
                         }
                     }
@@ -97,7 +97,7 @@ public final class BiomeRangeMap
 
         if (last == null)
         {
-            System.out.println("Warning: found NULL biome for T: " + temperature + " H: " + humidity + " A: " + altitude + " V: " + variety);
+            LOGGER.warn("Warning: found NULL biome for T: {} H: {} A: {} V: {}", temperature, humidity, altitude, variety);
         }
         return last;
     }
@@ -152,7 +152,7 @@ public final class BiomeRangeMap
         }
         catch (Exception e)
         {
-            e.printStackTrace();
+            LOGGER.error("Failed to save BiomeLookup image!", e);
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index 29ef04308..d894a238d 100644
--- a/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -1,5 +1,7 @@
 package net.minecraft.core.world.chunk;
 
+import com.mojang.logging.LogUtils;
+import net.minecraft.core.Global;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.MathHelper;
@@ -9,11 +11,13 @@ import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.EntityBlock;
+import org.slf4j.Logger;
 
 import java.util.*;
 
 public class Chunk
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
     public static final int CHUNK_SIZE_X = 16;
     public static final int CHUNK_SIZE_Z = 16;
     public static final int CHUNK_SECTIONS = 16;
@@ -440,7 +444,7 @@ public class Chunk
         int z = MathHelper.floor(entity.z / CHUNK_SIZE_Z);
         if(x != xPosition || z != zPosition)
         {
-            System.out.println("Wrong location! " + entity);
+            LOGGER.warn("Wrong location! {}", entity);
             Thread.dumpStack();
         }
         int section = MathHelper.clamp(MathHelper.floor(entity.y / 16D), 0, CHUNK_SECTIONS - 1);
@@ -514,7 +518,7 @@ public class Chunk
         blockEntity.z = zPosition * CHUNK_SIZE_Z + z;
         if (getBlockID(x, y, z) == 0 || !(Block.blocksList[getBlockID(x, y, z)] instanceof EntityBlock))
         {
-            System.out.println("Attempted to place a tile entity where there was no entity tile!");
+            LOGGER.warn("Attempted to place a tile entity where there was no entity tile!");
         }
         else
         {
diff --git a/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java b/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
index d2b82cd93..41b6334c4 100644
--- a/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
+++ b/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.world.chunk;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.Global;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
@@ -17,14 +18,16 @@ import net.minecraft.core.world.data.ChunkUnsignedByteArray;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.world.save.LevelData;
+import org.slf4j.Logger;
 
 import java.io.*;
+import java.nio.file.Files;
 import java.util.*;
 
 public class ChunkLoaderLegacy
     implements IChunkLoader
 {
-
+    private static final Logger LOGGER = LogUtils.getLogger();
     public ChunkLoaderLegacy(File worldDir, boolean createIfNecessary)
     {
         this.worldDir = worldDir;
@@ -86,22 +89,22 @@ public class ChunkLoaderLegacy
         {
             try
             {
-                FileInputStream fileStream = new FileInputStream(file);
+                InputStream fileStream = Files.newInputStream(file.toPath());
                 CompoundTag tag = NbtIo.readCompressed(fileStream);
                 if(!tag.containsKey("Level"))
                 {
-                    System.out.println("Chunk file at " + x + "," + z + " is missing level data, skipping");
+                    LOGGER.warn("Chunk file at {},{} is missing level data, skipping", x, z);
                     return null;
                 }
                 if(!tag.getCompound("Level").containsKey("Blocks"))
                 {
-                    System.out.println("Chunk file at " + x + "," + z + " is missing block data, skipping");
+                    LOGGER.warn("Chunk file at {},{} is missing block data, skipping", x, z);
                     return null;
                 }
                 Chunk chunk = loadChunkIntoWorldFromCompound(world, tag.getCompound("Level"));
                 if(!chunk.isAtLocation(x, z))
                 {
-                    System.out.println("Chunk file at " + x + "," + z + " is in the wrong location; relocating. (Expected " + x + ", " + z + ", got " + chunk.xPosition + ", " + chunk.zPosition + ")");
+                    LOGGER.warn("Chunk file at {},{} is in the wrong location; relocating. (Expected {}, {}, got {}, {})", x, z, x, z, chunk.xPosition, chunk.zPosition);
                     tag.putInt("xPos", x);
                     tag.putInt("zPos", z);
                     chunk = loadChunkIntoWorldFromCompound(world, tag.getCompound("Level"));
@@ -111,7 +114,7 @@ public class ChunkLoaderLegacy
             }
             catch(Exception exception)
             {
-                exception.printStackTrace();
+                LOGGER.error("Exception while attempting to load chunk at X:{}, Z:{}", x, z, exception);
             }
         }
         return null;
@@ -131,7 +134,7 @@ public class ChunkLoaderLegacy
         try
         {
             File tmpChunkFile = new File(worldDir, "tmp_chunk.dat");
-            FileOutputStream fileStream = new FileOutputStream(tmpChunkFile);
+            OutputStream fileStream = Files.newOutputStream(tmpChunkFile.toPath());
             CompoundTag levelTag = new CompoundTag();
             CompoundTag chunkDataTag = new CompoundTag();
             levelTag.put("Level", chunkDataTag);
@@ -148,7 +151,7 @@ public class ChunkLoaderLegacy
         }
         catch(Exception exception)
         {
-            exception.printStackTrace();
+            LOGGER.error("Exception while attempting to save chunk at X:{}, Z:{}", chunk.xPosition, chunk.zPosition, exception);
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegion.java b/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegion.java
index 0e4f16d97..025affe31 100644
--- a/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegion.java
+++ b/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegion.java
@@ -1,16 +1,19 @@
 package net.minecraft.core.world.chunk;
 
+import com.mojang.logging.LogUtils;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.save.LevelData;
 import net.minecraft.core.world.save.mcregion.RegionFileCache;
 import com.mojang.nbt.NbtIo;
+import org.slf4j.Logger;
 
 import java.io.*;
 
 public class ChunkLoaderRegion
     implements IChunkLoader
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
     private final File worldDir;
 
     public ChunkLoaderRegion(File worldDir)
@@ -34,13 +37,13 @@ public class ChunkLoaderRegion
         }
         if(!tag.containsKey("Level"))
         {
-            System.out.println("Chunk file at " + x + "," + z + " is missing level data, skipping");
+            LOGGER.warn("Chunk file at {},{} is missing level data, skipping", x, z);
             return null;
         }
         Chunk chunk = ChunkLoaderLegacy.loadChunkIntoWorldFromCompound(world, tag.getCompound("Level"));
         if(!chunk.isAtLocation(x, z))
         {
-            System.out.println("Chunk file at " + x + "," + z + " is in the wrong location; relocating. (Expected " + x + ", " + z + ", got " + chunk.xPosition + ", " + chunk.zPosition + ")");
+            LOGGER.warn("Chunk file at {},{} is in the wrong location; relocating. (Expected {}, {}, got {}, {})", x, z, x, z, chunk.xPosition, chunk.zPosition);
             tag.putInt("xPos", x);
             tag.putInt("zPos", z);
             chunk = ChunkLoaderLegacy.loadChunkIntoWorldFromCompound(world, tag.getCompound("Level"));
@@ -68,7 +71,7 @@ public class ChunkLoaderRegion
         }
         catch (Exception exception)
         {
-            exception.printStackTrace();
+            LOGGER.error("Exception while attempting to save chunk at X:{}, Z:{}", chunk.xPosition, chunk.zPosition, exception);
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegionAsync.java b/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegionAsync.java
index a3654058e..c4d6edc21 100644
--- a/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegionAsync.java
+++ b/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegionAsync.java
@@ -1,6 +1,8 @@
 package net.minecraft.core.world.chunk;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.world.World;
+import org.slf4j.Logger;
 
 import java.io.File;
 import java.io.IOException;
@@ -13,6 +15,7 @@ import java.util.concurrent.locks.ReentrantLock;
 public class ChunkLoaderRegionAsync
     implements IChunkLoader
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
     private static final Queue<Chunk> chunksToSave = new LinkedList<>();
     private static final Queue<World> worldsToSave = new LinkedList<>();
     private static final Queue<ChunkLoaderRegion> chunkLoaders = new LinkedList<>();
@@ -86,7 +89,7 @@ public class ChunkLoaderRegionAsync
                         notEmpty.await();
                     }
                 } catch (IOException | InterruptedException e) {
-                    e.printStackTrace();
+                    LOGGER.error("Exception while attempting to save chunks in async loader", e);
                 } finally {
                     lockChunksToSave.unlock();
                 }
